\\ Copyright 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
\\ default(parisizemax,300*10^6);
read("../vpar.gp");
read("../vpar-wip.gp");
read("memoize.gp");
setrand(getwalltime()%2^32);


check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong: "name);
     print("got  "got);
     print("want "want);
     quit(1),
     option_verbose,
     print("ok "check_count" "name));
}

vector_is_nondecreasing(v) = \
  for(i=2,#v, if(v[i]<v[i-1], return(0))); 1;

T(n) = if(n<=1,1, n^(n-1));
C(n) = if(n<=1,1, sum(t=1,n, C(n-t) * t^(t-1)));
C=memoize(C);
check_exact(C(0),1);
check_exact(C(1),1);
check_exact(C(2),3);

\\------------------------------------------------------------------------------

{check_exact( 2 + 2*'n/('k*('n-'k)) - ( 2 + 2*'n/(('k+1)*('n-'k-1))),
            2*'n*(('k+1)*('n-'k-1) - ('k*('n-'k)))
            / ( 'k*('n-'k) * ('k+1)*('n-'k-1) ));}

check_exact( ('k+1)*('n-'k-1) - ('k*('n-'k)),   'n - 2*'k - 1);

{check_exact( 2 + 2*'n/('k*('n-'k)) - ( 2 + 2*'n/(('k+1)*('n-'k-1))),
            2*'n*('n - 2*'k - 1) / ( 'k*('n-'k) * ('k+1)*('n-'k-1) ));}

\\ n-2k-1 >= n-2n/2-1 = -1

\\ at k, diff k-1 subtract k
{check_exact( ( 2 + 2*'n/(('k-1)*('n-'k+1))) - (2 + 2*'n/('k*('n-'k))) ,
            -2*'n*(('k-1)*('n-'k+1) - ('k*('n-'k)))
            / ( 'k*('n-'k) * ('k-1)*('n-'k+1) ));}

{check_exact( ( 2 + 2*'n/(('k-1)*('n-'k+1))) - (2 + 2*'n/('k*('n-'k))),
            2*'n*( 'n - 2*'k + 1 )
            / ( 'k*('n-'k) * ('k-1)*('n-'k+1) ));}

\\ with k<=n/2
\\ n - 2*k + 1 >= n - 2*n/2 + 1 >= 1
\\ so factor k-1 is bigger than k

\\ with k<=n/2
\\ k^(k-1) * (n-k)^(n-k-1) * (2 + 1/k + 1/(n-k))
\\ cmp
\\ (k+1)^k * (n-k-1)^(n-k-2) * (2 + 1/(k+1) + 1/(n-k-1))

\\ k^(k-1) * (n-k)^(n-k-1) / ( (k+1)^k * (n-k-1)^(n-k-2) )
\\ = (k/(k+1))^(k-1) * ((n-k)/(n-k-1))^(n-k-2) * (n-k-1) / (k+1)
\\ 
\\ my(n=100,k=5); (k/(k+1))^(k-1) * ((n-k)/(n-k-1))^(n-k-2) * 1.0

\\ my(n=100,k=5); ( (k-1)^(k-2) * (n-k+1)^(n-k) ) / ( k^(k-1) * (n-k)^(n-k-1) )
\\ my(n=100,k=5); ((k-1)/k)^(k-2) * ((n-k+1)/(n-k))^(n-k-1) * (n-k+1) / k
\\ my(n=100,k=5); ((k-1)/k)^(k-2) * ((n-k+1)/(n-k))^(n-k-1) * (n-k+1) / k *1.0
\\ my(n=100,k=5); ((k-1)/k)^(k-2) * ((n-k+1)/(n-k))^(n-k-1) * 1.0

C_upper_factor(n) = 1+2/n;
check_exact(C_upper_factor('n-1) + C_upper_factor(1), 2*(2*'n-1)/('n-1));
check_exact(T(2),2);
check_exact(C(2)/T(2),3/2);

\\ term k=n is T(n)
\\ term k=1 is <= (n-1)^(n-2) * (2 + 2/(n-1))
\\             = (n-1)^(n-2) * 2*n/(n-1)
\\             = (n-1)^(n-3) * 2*n
\\             < n^(n-3) * 2/e * 2*n
\\             = n^(n-2) * 4/e
\\             = 4/e*1/n * T(n)
\\ term k=2 is <= (n-2)^(n-3) * (1 + 2/(n-2) + 3/2)
\\              = (n-2)^(n-3) * (5*n-6)/2 / (n-2)
\\              = (n-2)^(n-4) * (5*n-6)/2
\\              < n^(n-4) * 2/e * (5*n-6)/2
\\              < n^(n-4) * 2/e * 5*n/2
\\              = n^(n-4) * 5/e * n
\\              = 1/n^3 * 5/e * T(n)
\\ times n/2 terms
\\              = 1/n^2 * 5/2/e * T(n)
\\ total
\\ 4/e*1/n + 5/e^2 * 1/n
\\ (4/e + 5/2/e/n) * 1/n
\\ 4*exp(-1) + 5*exp(-2)     \\ 2.148


vector(1,n,n+=50; (n-1)^(n-1) / n^(n-1) * 1.0)
vector(1,n,n+=5; n^(n-3))
vector(1,n,n+=5; n^(n-3))
vector(10,n,n+=3; (n-1)^(n-3) < 2*exp(-1) * n^(n-3))
vector(10,n,n+=4; (n-2)^(n-4) < 2*exp(-1) * n^(n-4))

\\ my(n=100); ((n+1)/n)^n * 1.0  \\ -> e from below
\\ my(n=1); ((n+1)/n)^n == 2
\\ (n+1)^n / n^n < e
\\ 1/e * (n+1)^n < n^n 
\\ (n+1)^n / n^n >= 2
\\ (n+1)^n  >= 2 * n^n
\\ 1/2 * (n+1)^n >= n^n

vector(10,n, (n+1)^n / n^n >= 2)
vector(10,n, (n+1)^n / n^n *1.0)

vector(10,n,n+=2; (n-1)^(n-3) / n^(n-3) )
vector(10,n,n+=2; (n-1)^(n-3) / n^(n-3) * 1.0 )

\\------------------------------------------------------------------------------

\\ 4^3 * 96^95 * 121/48  factor 2.5208333333  frac 3.3380377643 E-6 rat 38.918089940
\\ 5^4 * 95^94 * 46/19  factor 2.4210526316  frac 1.2187177746 E-7 rat 27.389752031
\\
\\ 5^3/4^3*1.0  \\ 1.95 < e
\\ 5^4/4^3*1.0  \\ 9.76 < 5*e
\\ 5*exp(1)     \\ 13
\\ 95^96/96^95*1.0  \\ 35
\\ 2*95 * exp(-1)   \\ 69.8
\\ so factor k/(n-k)*2
check_exact('k/('n-'k), 1/('n/'k - 1));
\\ my(k=5,n=100); k/(n-k)*2 == 2/19

n=100;
default(realprecision,11);
C_upper_factor(n) = if(n<=1, 1, (1+2/n));
C_upper(n) = C(n)*C_upper_factor(n);
{
  my(c=0,prev=0,frac_total=0);
  for(k=1,ceil(n/2),
     my(f=(C_upper_factor(k) + C_upper_factor(n-k)));
     my(t=T(k) * T(n-k) * f);
     my(rat=if(prev,prev/t) *1.0);
     my(this_frac=t/ (T(n)/n) *1.0);
     print(k"^"k-1" * "n-k"^"n-k-1" * ",f,
           "  factor "f*1.0,
           "  frac "this_frac,
           " rat "rat);
     c += t;
     frac_total += this_frac;
     prev=t);
  print(T(n));
  c += T(n);
  print(c*1.0"  sum");
  print(T(n) + T(n-1)*4*n*ceil(n/2)"  T(n) + est");
  print(frac_total,"  frac total");
}
print(C_upper(n)*1.0"  C_upper(n)");
print(C(n)" C(n)");


check_exact(1+2/'k + 1+2/('n-'k),  2 + 2*'n/('k* ('n-'k)))

quit;


\\------------------------------------------------------------------------------

n=10;
default(realprecision,11);
{
  my(c=0);
  for(k=1,n,
     print(T(k)" * "C(n-k));
     c += T(k)*C(n-k));
  print(c);
}
print(C(n)" C(n)");
print(T(n) + 2*sum(k=1,n-1, k*T(k)),"  T(k) cumulative");
print(T(n)*n/(n-1.0),"  T(n) * n/(n-1)");
print(T(n)*(n+1.0)/n,"  T(n) * (n+1)/n first few too small");
print(T(n) + exp(1)*T(n-1),"  T(n) and e*T(n-1)");
print();

C_upper_factor(n) = if(n<=1, 1, (1+2/n));
C_upper(n) = C(n)*C_upper_factor(n);
{
  my(c=0, prev=0);
  for(k=1,n-1,
     my(t=T(k) * C_upper(n-k));
     my(r = if(prev, max(prev,t)/min(prev,t)));
     print(k"^"k-1" * "n-k"^"n-k-1" * ",C_upper_factor(n-k),
           "  "T(k)," * ",C_upper(n-k)*1.0
           "  frac "t/T(n)*1.0*(n-1),
           "  rat "r*1.0);
     c += t;
     prev=t);
  print(T(n));
  c += T(n);
  print(c*1.0"  sum");
}
print(C_upper(n)*1.0"  C_upper(n)");

{
  print(vector(20,n,n++; C(n) < T(n)*n/(n-1)));
  my(n=1000);
  print(C(n) < vpar_count(n)*(1+1/n) );
  quit;
}

quit;


\\  [1....x] [x+1..y] [y+1..n]
\\   1..x,0   1..y,0   1..z,0


\\------------------------------------------------------------------------------

n=20;
{
  for(t=1,n,
     \\ printf("%30d %30d\n", t^(t-1), C(n-t));
     \\ print(t^(t-1) * C(n-t));
     printf("%f\n", T(t) * C(n-t) / vpar_count(n,1) * 1.0);
  );
  print("tot");
  printf("%f\n", sum(t=1,n-1, T(t) * C(n-t)) / vpar_count(n,1) * 1.0);

  \\ C upper bounds ok
  printf("%f\n", sum(t=1,n-1, T(t) * T(n-t)*(1+2/(n-t))) / vpar_count(n,1) * 1.0);
  printf("%f\n", T(n) * (0+2/n) / vpar_count(n,1) * 1.0);
  quit;
}

{
  \\ raising all as (n-1) * C(n-t) * t^(t-1) with biggest t=1 is too big
  for(n=1,100,
     my(t=1);
     print((n-1) * C(n-t) * t^(t-1) / vpar_count(n,1) * 1.0 );
  );
  quit;
}

{
  for(n=1,100,
     printf("%20f %20f\n",
            sum(t=1,n-1, C(n-t) * t^(t-1)) / vpar_count(n,1) * 1.0,
            C(n) / vpar_count(n,1) * 1.0 * 1/n
           );
  );
  quit;
}


\\------------------------------------------------------------------------------
\\ Stirling's approximation n! -> 1/exp(n) * n^n * sqrt(n)

T_upper(n) = if(n<1, 1, exp(n-1) * (n-1)!);     \\ WRONG
T_lower(n) = if(n<2, 0, exp(n-2) * (n-2)!);
check_exact(vector(20,n,n--; T_lower(n) <= T(n)), vector(20,n,1));
check_exact(vector(20,n,n--; T(n) <= T_upper(n)), vector(20,n,1));


\\------------------------------------------------------------------------------

\\ not in OEIS: 1, 2, 5, 22, 150, 1414, 17139, 254502, 4476052, 90978310, 2097985685, 54109563894, 1543142394438, 48213897782278, 1637692888475175, 60085580997077062
\\ superseek nothing
{
  for(n=0,15,
     print1(sum(k=0,n, T(k)*T(n-k)),", "));
  print();
}

\\ not in OEIS: 1, 3, 13, 86, 789, 9363, 136853, 2378900, 47931589, 1097985685
{
  for(n=0,10,
     print1(sum(k=1,n, T(k)*T(n-k)),", "));
  print();
}

{
  for(n=2,15,
     my(t=sum(k=1,n, T(k)*T(n-k)));
     print(ceil(exp(n-3)*sum(k=1,n-3,(n-3)!*(n-k-3)!)) < t,
           " ",
           t < floor(exp(n-1)*sum(k=1,n-1,(n-1)!*(n-k-1)!))));
}
quit

\\------------------------------------------------------------------------------
\\ A003149(n)/n! -> 2

A003149(n) = sum(k=0,n, k!*(n-k)!);
for(n=0,10, print(A003149(n)/n!*1.0));
my(n=1000); print(A003149(n)/n!*1.0);
my(n=10000); print(A003149(n)/n!*1.0);
quit

\\------------------------------------------------------------------------------

\\ 1, 2, 5, 16, 64, 312, 1812, 12288, 95616
\\ A003149 sum
{
  for(n=0,8,
     print1(sum(k=0,n, k!*(n-k)!),", "));
  print();
}

\\ 1, 3, 10, 40, 192, 1092, 7248, 55296
\\ A136128 number of components in permutations 1..n
{
  for(n=1,8,
     print1(sum(k=1,n, k!*(n-k)!),", "));
  print();
}

\\ 1, 4, 24, 240, 4080, 110880, 4404960, 238452480,
\\ A061640 a(n) = !n*n!
{
  for(n=1,8,
     print1(sum(k=1,n, n!*(n-k)!),", "));
  print();
}

\\ 1, 3, 9, 33, 153, 873, 5913, 46233
\\ A007489 sum
{
  for(n=1,8,
     print1(sum(k=1,n, k!),", "));
  print();
}

\\ 1, 2, 4, 10, 34, 154, 874, 5914, 46234
\\ A003422 left factorial sum
{
  for(n=0,8,
     print1(sum(k=0,n, k!),", "));
  print();
}
quit


\\------------------------------------------------------------------------------

{
  for(n=2,10,
     printf("%d %d\n",
            ceil(exp(n-2)*(n-2)!) < T(n), T(n) < ceil(exp(n-1)*(n-1)!));
     );
}
quit


\\------------------------------------------------------------------------------

A000169(n) = n^(n-1);
A088342_sumprodvec(n) =
{
  if(n==0,return([[]]));
  if(n==1,return([[1]]));
  my(l=List([]));
  for(t=1,n,
     my(tt=t^(t-1));
     listput(l, apply(v->concat(v,[tt]), A088342_sumprodvec(n-t))));
  concat(Vec(l));
}
vecprod(v) = prod(i=1,#v,v[i]);
spv(v) = sum(i=1,#v, vecprod(v[i]));
A088342_sumprodvec = memoize(A088342_sumprodvec);
A088342_sumprodvec(1)
A088342_sumprodvec(2)
A088342_sumprodvec(3)
spv(A088342_sumprodvec(3))
A088342_sumprodvec(4)
spv(A088342_sumprodvec(4))
A088342_sumprodvec(5)
spv(A088342_sumprodvec(5))
A088342_sumprodvec(6)
spv(A088342_sumprodvec(6))
A088342_sumprodvec(7)
vecsum(apply(vecprod,A088342_sumprodvec(7)))
spv(A088342_sumprodvec(7))
apply(vecprod,A088342_sumprodvec(7))
vector(7,n, A000169(n))
apply(length,A088342_sumprodvec(7))
quit


\\------------------------------------------------------------------------------

\\ 2^n compositions of n (bit run lengths)

\\ forest single tree is n^(n-1) ways

\\ forest 2 trees is (n-1)^(n-2) * 2 compositions  -> 0
n=100000;
n^(n-1) / (n+1)^(n-1) * 1.0
(n-1)^(n-1) / (n+1)^(n-1) * 1.0        \\ exp(-2)
2*(n-1)^(n-2) / (n+1)^(n-1) * 1.0
2*((n-1)/(n+1))^(n-2) / (n+1) * 1.0

\\ 2^n compositions  binomial(n,l) of l parts

quit

\\------------------------------------------------------------------------------

tfunc(n) = if(n==0,0,n^n);
tfunc(n) = if(n==0,0,n^(n-1));
tfunc(n) = if(n==0,0, n^(n/3));
limit = 50;
tvec = vector(limit,n,n--; tfunc(n))
tpol = Polrev(tvec) + O(x^limit)
apol = tpol/(1-tpol)
avec = concat(vector(valuation(apol,'x)),Vec(apol))
rvec = vector(min(#avec,#tvec),i, if(tvec[i], avec[i]/tvec[i]*1.0))
quit


\\------------------------------------------------------------------------------

\\ a(n) = n^(n-1) = e^(an);
\\ t(n) = n^(n-1) = e^(bn);
\\ A(x) = T(x)/(1 - T(x))
\\ sum e^(a*i) * e^(b*(n-i))
\\     e^(ai+bn-bi)
\\     e^(bn+(a-b)i)
\\default(realprecision,60);
\\
\\ A(x) = T(x)/(1 - T(x))
\\ A(x) = T(x)/(1 - T(x))
\\ A(x)/T(x) = 1 - T(x)


A088342_vector(n) =
{
  my(a=vector(n));
  for(i=1,n, a[i]=sum(t=1,i, if(i==t,1,a[i-t])*t^(t-1)));
  a;
}
A088342(n) = A088342_vector(n)[n];

A000169(n) = n^(n-1);
for(k=1,9,my(n=2^k); print(A088342(n)/A000169(n)*1.0));
print();

A000272(n) = (n+1)^(n-1);
for(k=1,10,my(n=2^k); print(A088342(n)/A000272(n)*1.0));


A088342_vector(10)
vector(8,n,A000169(n))

A088342_samples = [1, 3, 14, 93, 837, 9742, 140449, 2420297, 48506250];
vector(#A088342_samples,n, A088342(n)) == A088342_samples || error();

A000169_samples = [1, 2, 9, 64, 625];
vector(#A000169_samples,n, A000169(n)) == A000169_samples || error();

quit



my(n=10000); (n+1)^(n-1) / n^(n-1) * 1.0
my(n=1000); ((n+1)/n)^(n-1) * 1.0
my(n=1000); (1+1/n)^(n-1) * 1.0


1 + suminf(i=1, (-1)^i*1/i!)
\\ 0.367879441171442321595523
\\ = 1/e
\\ derangements fraction

for(n=1,20, print(n^(n-1)/n! * 1.0))


\\------------------------------------------------------------------------------

{
  for(n=1,30,
     print("n="n);
     my(c=vpar_count_contiguous_forests(n),
        t=vpar_count(n),
        f=vpar_count(n,1));
     printf("%50d trees\n", t);
     printf("%50d total\n%50d contig\n%50d non\n", f, c, f-c);
);
}
quit


\\------------------------------------------------------------------------------

\\ n=9     3*3 * 6*6*6*6*6*6*6
\\       / 9 9   9 9 9 9 9 9 9

S(n) =
{
  sum(t=1,n-2, (n-t-1)^(n-t+1) * t^(t-1))
               / (n-1)^n                      / (n-1);
}
for(n=2,10, print(S(n)*1.0));
quit

\\ c = 


\\------------------------------------------------------------------------------

\\ maybe towards 0.368...
\\ for(n=1,20,my(n=2^n); print(vpar_count_contiguous_forests(n)/vpar_count(n,1)*1.0));
\\
\\ C(n) = if(n==0,1, sum(t=1,n, C(n-t) * t^(t-1)));
\\ c(n) = C(n)/ (n-1)^(n+1)

\\ (n-t-1) * ... * t
\\ -----------------
\\    n            n
 
check_exact(vpar_count_contiguous_forests(0), 1);
check_exact(vpar_count_contiguous_forests(1), 1);
check_exact(vpar_count_contiguous_forests(2), 3);

C(n) = if(n<=1,1, sum(t=1,n, C(n-t) * t^(t-1)));
C=memoize(C);

c(n) =
{
  if(n<=2, C(n)/(n-1)^(n+1),

     (n/(n-1))^(n-1) / (n-1)^2
     +
     1 / (n-1)^3
     +
     sum(t=1,n-2, c(n-t) * (n-t-1)^(n-t+1) * t^(t-1))
                         / (n-1)^n                      / (n-1)
    );
}
c=memoize(c);
\\ print("n="n" t="t" base "n-t-1);
\\ n=9     3*3 * 6*6*6*6*6*6*6
\\       / 9 9   9 9 9 9 9 9 9

for(n=2,10, print(vpar_count_contiguous_forests(n)/(n-1)^(n+1)));
for(n=2,10, print(C(n)/(n-1)^(n+1)));
for(n=3,10, print(C(n)/(n-1)^(n+1),"  ",c(n)));
quit


\\------------------------------------------------------------------------------
\\ component number is increasing

\\ n= 1  2
\\    1, 3, 14, 93, 837, 9742, 140449,
\\ A088342 rooted labelled trees summed

vector(8,n,n--; vpar_count_contiguous_forests(n))

{
  for(n=1,10,
     my(count=0);
     forvec(vec=vpar_forvec_from(n,1), \\ forests
           my(vpar=vpar_from_upascend(vec));
           my(components =vpar_compnum_vector(vpar));
           if(vector_is_nondecreasing(components),
              count++));
     print(count","););
  quit;
}


\\------------------------------------------------------------------------------
